/*
 * Copyright (C) 1997  Warren Jasper
 * All rights reserved.
 *
 */

/*
 * dio24H.h
 */

/* General defines */

#define TRUE  1
#define FALSE 0
#define BYTE unsigned char
#define WORD unsigned short
#define LONG unsigned long

/* #define DEBUG  */

#define DIO24H_BASE     0x350      /* Default base address */

/* Default device major number */
#ifndef DEFAULT_MAJOR_DEV
#define DEFAULT_MAJOR_DEV  39    /* Default Major Device Number */
#endif

#define ENABLE_INTERRUPTS FALSE  /* FALSE = disable ,  TRUE = enable           */
#define DIO_IRQ             7    /* IRQ interrupts ( 2-7 )                     */
#define DIO_PORTS           3    /* 24 Digital I/O Ports (3 bytes)             */
#define PORT_MIN         0x200   /* minimum base address used in autodetecting */
#define PORT_MAX         0x3e0   /* maximum base address allowed by board      */
#define PORT_STEP        0x4     /* base step ( 4 bytes)                       */
#define PORT_SIZE        0x4     /* uses 4 bytes of registers                  */

/* I/O Register locations */

/* NOTE: base_reg to be found dynamically at boot time. Not hard coded into driver */

#define DIO_PORTA           (base_reg)    /* Port A 8 bit I/O of 8255 */
#define DIO_PORTB           (base_reg+1)  /* Port B 8 bit I/O of 8255 */
#define DIO_PORTC           (base_reg+2)  /* Port C 4+4 bit of 8255 */
#define DIO_CNTRL_REG       (base_reg+3)  /* Mode and Direction Control Register */


/* Values kept for each channel. */

typedef struct CHANNEL_REC {
  int  open;              /* Is channel device open()    */
  WORD value;             /* value of DIO Channel        */
  WORD addr;              /* address of the channel      */
  int mode;               /* mode for 8255               */
  unsigned short f_flags; /* flags sent by open()        */
} ChanRec;


